#pragma once

#include "CoreMinimal.h"
#include "Presenter.h"
#include "Templates/SubclassOf.h"
#include "TallyMenuPresenter.generated.h"

class UUserWidget;
class UTallyScoreboardSubPresenter;
class UChatSubPresenter;

UCLASS(Blueprintable, EditInlineNew)
class DBDUIPRESENTERS_API UTallyMenuPresenter : public UPresenter
{
	GENERATED_BODY()

public:
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	TSubclassOf<UUserWidget> CoreTallyMenuWidgetClass;

private:
	UPROPERTY(BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	UTallyScoreboardSubPresenter* _tallyScoreboardSubPresenter;

	UPROPERTY(BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	UChatSubPresenter* _chatSubPresenter;

private:
	UFUNCTION(BlueprintCallable)
	void SetTallyScoreboardVisibility(bool isVisible) const;

public:
	UTallyMenuPresenter();
};

FORCEINLINE uint32 GetTypeHash(const UTallyMenuPresenter) { return 0; }
